import pyttsx3  # Text-to-speech conversion
import speech_recognition as sr  # Recognize speech
import datetime  # Get time
import webbrowser  # Open websites
import os  # System commands

def speak(text):
    engine = pyttsx3.init()
    engine.say(text)
    engine.runAndWait()

def listen():
    recognizer = sr.Recognizer()
    with sr.Microphone() as source:
        print("Listening...")
        recognizer.pause_threshold = 1
        try:
            audio = recognizer.listen(source)
            command = recognizer.recognize_google(audio, language='en-in')
            print(f"You said: {command}")
            return command.lower()
        except sr.UnknownValueError:
            print("Sorry, I couldn't understand.")
            return ""
        except sr.RequestError:
            print("Network issue.")
            return ""

def execute_command(command):
    if 'time' in command:
        time = datetime.datetime.now().strftime('%H:%M:%S')
        speak(f"The time is {time}")
    elif 'open google' in command:
        speak("Opening Google")
        webbrowser.open("https://www.google.com")
    elif 'open youtube' in command:
        speak("Opening YouTube")
        webbrowser.open("https://www.youtube.com")
    elif 'play music' in command:
        music_dir = "C:\\Users\\Public\\Music"  # Change path as needed
        songs = os.listdir(music_dir)
        if songs:
            os.startfile(os.path.join(music_dir, songs[0]))
            speak("Playing music")
        else:
            speak("No music found.")
    elif 'exit' in command:
        speak("Goodbye!")
        exit()
    else:
        speak("Sorry, I can't do that yet.")

if __name__ == "__main__":
    speak("Hello, I am Jarvis. How can I assist you?")
    while True:
        user_command = listen()
        if user_command:
            execute_command(user_command)